import es, playerlib, votelib, gamethread, random, usermsg, os.path, urllib, time, popup

try:
	import levels
	from levels import *
except:
	es.msg('#multi', '#lightgreen[Zombie Containment]: #defaultERROR: Corrupt levels.py, cannot load Zombie Containment!')
	es.msg('#multi', '#lightgreen[Zombie Containment]: #defaultTerminating proccess, please double check your levels.py!')
	raise ImportError('[Zombie Containment]: Could not load levels.py, please syntax check')

# The only options that are in here are dictionary options that I'm too lazy to make for server vars but will be eventually
### Dict Options ###

# The time between respawn waves
respawn_rate = 20

# The ammount of time you are protected after spawning
# 0 = Disabled
spawn_protection = 7


ammo = {
	'ammo_338mag_max': 666,
	'ammo_357sig_max': 666,
	'ammo_45acp_max': 666,
	'ammo_50AE_max': 666,
	'ammo_556mm_box_max': 666,
	'ammo_556mm_max': 666,
	'ammo_57mm_max': 666,
	'ammo_762mm_max': 666,
	'ammo_9mm_max': 666,
	'ammo_buckshot_max': 666
}

timeofday = {
	0: 'Day 1 | 7:00pm',
	1: 'Day 1 | 9:25pm',
	2: 'Day 1 | 10:40pm',
	3: 'Day 2 | 12:15am',
	4: 'Day 2 | 3:30am',
	5: 'Day 2 | 7:20am',
	6: 'Day 2 | 10:35am',
	7: 'Day 2 | 12:52pm',
	8: 'Day 2 | 2:05pm',
	9: 'Day 2 | 4:20pm',
	10: 'Day 2 | 7:00pm',
	11: 'Day 2 | 9:25pm',
	12: 'Day 2 | 10:40pm',
	13: 'Day 3 | 12:15am',
	14: 'Day 3 | 3:30am',
	15: 'Day 3 | 7:20am',
	16: 'Day 3 | 10:35am',
	17: 'Day 3 | 12:52pm',
	18: 'Day 3 | 2:05pm',
	19: 'Day 3 | 4:20pm',
	20: 'Day 3 | 7:00pm',
	21: 'Day 3 | 9:25pm',
	22: 'Day 3 | 10:40pm',
	23: 'Day 4 | 12:15am',
	24: 'Day 4 | 3:30am',
	25: 'Day 4 | 7:20am',
	26: 'Day 4 | 10:35am',
	27: 'Day 4 | 12:52pm',
	28: 'Day 4 | 2:05pm',
	29: 'Day 4 | 4:20pm',
	30: 'Day 4 | 7:00pm',
	31: 'Day 4 | 9:25pm',
	32: 'Day 4 | 10:40pm',
	33: 'Day 5 | 12:15am',
	34: 'Day 5 | 3:30am',
	35: 'Day 5 | 7:20am',
	36: 'Day 5 | 10:35am',
	37: 'Day 5 | 12:52pm',
	38: 'Day 5 | 2:05pm',
	39: 'Day 5 | 4:20pm',
	40: 'Day 5 | 7:00pm',
	41: 'Day 5 | 9:25pm',
	42: 'Day 5 | 10:40pm'
}

difficultylevel = {
	0: 'Easy',
	1: 'Normal',
	2: 'Hard',
	3: 'Impossible'
}

infectionorrespawn = {
	0: 'Respawn Mode',
	1: 'Infection Mode'
}

#### No Config Below ####
### Addon Info ###

info = es.AddonInfo() 
info['name']        = "Zombie Containment" 
info['version']     = "1.3" 
info['author']      = "el_cabong" 
info['url']         = "" 
info['description'] = "a zombie rpg/survival mode game based on a striped down version of Bonbon's Zombie Horror 1.1.0b" 

### Server Vars ### 

sv = es.ServerVar
es.ServerVar('gun').set(0)

sv_options = {
	'zc_zombie_health_min': 200,
	'zc_zombie_health_max': 300,
	'zc_zombie_health_level_bonus_multiplier': 3,
	'zc_zombie_player_health_multiplier': 1.5,
	'zc_zombie_speed_min': 0.8,
	'zc_zombie_speed_max': 1.2,
	'zc_zombie_speed_level_bonus_multiplier': 0.01,
	'zc_zombie_player_speed_multiplier': 0.01,
	'zc_zombie_armor_min': 50,
	'zc_zombie_armor_max': 100,
	'zc_zombie_armor_level_bonus_multiplier': 2,
	'zc_zombie_player_armor_multiplier': 5,
	'zc_zombie_gravity_min': 0.8,
	'zc_zombie_gravity_max': 1.2,
	'zc_zombie_gravity_level_multiplier': 0.05,
	'zc_zombie_models': 'player/elis/uz1/uz1,player/slow/classic_zombie/classic_zombie,player/slow/classic_zombie/classic_zombie_2,player/slow/classic_zombie/classic_zombie_4,player/slow/classic_zombie/classic_zombie_3',
	'zc_difficulty_health_multiplier': 10,
	'zc_difficulty_speed_multiplier': 0.01,
	'zc_difficulty_humanhealthsubtract_multiplier': 10,


	'zc_boss_chance': 10,
	'zc_boss_model': 'humans/corpse1',
	'zc_boss_health_min': 1000,
	'zc_boss_health_max': 3333,
	'zc_boss_player_health_multiplier': 300,
	'zc_boss_armor_min': 1000,
	'zc_boss_armor_max': 3333,
	'zc_boss_speed_min': 1,
	'zc_boss_speed_max': 1.75,
	'zc_boss_gravity_min': 0.75,
	'zc_boss_gravity_max': 1,


	'zc_megaboss': 0,
	'zc_restricted_weapons': 'flashbang,smokegrenade',
	'zc_stock_zombies': 5,
	'zc_stock_multiplier': 0,
	'zc_stock_add': 10,
	'zc_rounds_to_win': 5,
	'zc_survivalstart': 0,
	'zc_bots': 13,
	'zc_machine_gun_ammo': 100,
	'zc_headshot_only': 0,
	'zc_remove_ragdolls': 0,
	'zc_darkness': 'g',
	'zc_few_humans_hp_bonus': 15,
	'zc_start_hp_value': 450,
	'zc_per_human_hp_loss': 10,
	'zc_human_speed': 1.0,
	'zc_mapchange_1': 6,
	'zc_mapchange_2': 12,
	'zc_mapchange_3': 18
}

### Globals ###

t_wave_remaining = None
ct_wave_remaining = None
difvote = None
irvote = None
musicvote = None

infection = 0
difficulty = 1
survival = 1
messages = {}
temp_zombies = 0
wins = 0
checked = 0
coords = {}
bossess = []
help_menu = None
zc_command_args = {
	'add': {
		'levelmessage': [4, '<level> <message>'],
	},
}

### Loads ###
def load():
	global help_menu, survival
	add_downloads()
	for type in ammo:
		es.server.queuecmd('%s %s'%(type, ammo[type]))
	knife_bot()
	add_bots()
	##if zc_survivalstart == 1:
	##	survival = 1
	for a in sv_options:
		es.ServerVar(a).set(sv_options[a])
	if not es.exists('command', 'zc'):
		es.regcmd('zc', 'zombiecontainment/zc')
	es.server.queuecmd('mp_restartgame 2')
	set_pythonvars()
	if os.path.isfile(es.getAddonPath('zombiecontainment') + '/zombiecontainment.cfg'):
		es.server.queuecmd('es_xmexec ../addons/eventscripts/zombiecontainment/zombiecontainment.cfg')
	else:
		es.dbgmsg(0, 'Zombie Containment: Config not found')
	gamethread.delayed(2, resetAll)


	global difvote
	if not es.exists('saycommand', '!difficulty'): 
		es.regsaycmd('!difficulty', 'zombiecontainment/votedifficulty') 
	difvote = votelib.create('difvote', finishdif, submitdif)
	difvote.setquestion('Difficulty')
	difvote.addoption('Easy')
	difvote.addoption('Normal')
	difvote.addoption('Hard')
	difvote.addoption('Impossible')
	
	global irvote
	if not es.exists('saycommand', '!infection'): 
		es.regsaycmd('!infection', 'zombiecontainment/voteir') 
	if not es.exists('saycommand', '!respawn'): 
		es.regsaycmd('!respawn', 'zombiecontainment/voteir')
	irvote = votelib.create('irvote', finishir, submitir)
	irvote.setquestion('Infection or Respawn Mode')
	irvote.addoption('Respawn')
	irvote.addoption('Infection')
	
	global musicvote
	if not es.exists('saycommand', '!music'): 
		es.regsaycmd('!music', 'zombiecontainment/votemusic') 
	musicvote = votelib.create('musicvote', finishmusic, submitmusic)
	musicvote.setquestion('Music on or off')
	musicvote.addoption('on')
	musicvote.addoption('off')
	
	global survote
	if not es.exists('saycommand', 'gametype'): 
		es.regsaycmd('!gametype', 'zombiecontainment/votesur') 
	survote = votelib.create('survote', finishsur, submitsur)
	survote.setquestion('Story or Survival Mode')
	survote.addoption('Story')
	survote.addoption('Survival')			



def unload():
	kick_bots()
	for userid in es.getUseridList():
		gamethread.cancelDelayed('check_weapon_%s'%userid)
	es.lightstyle(0, 'g')
	es.server.queuecmd('exec server.cfg')
	for loop in ['update_hud', 'check_quota']:
		gamethread.cancelDelayed(loop)
	if es.exists('saycommand', '!difficulty'): 
		es.unregsaycmd('!difficulty')
	if es.exists('saycommand', '!gametype'): 
		es.unregsaycmd('!gametype')
	if es.exists('saycommand', '!music'): 
		es.unregsaycmd('!music')
	if es.exists('saycommand', '!infection'): 
		es.unregsaycmd('!infection')
	if es.exists('saycommand', '!respawn'): 
		es.unregsaycmd('!respawn')
	survote.delete()	 
	difvote.delete()
	irvote.delete()
	musicvote.delete()
	gamethread.cancelDelayed('waveRepeat_delay')

### Events ###

def player_activate(ev):
	gamethread.cancelDelayed('update_hud')
	update_hud()

def player_spawn(ev):
	userid = ev['userid']
	Player(userid).set_attributes(1)
	Player(userid).health_bonus()
	Player(userid).check_team()
	Player(userid).player_spawn_msg()
	gamethread.cancelDelayed('update_hud')
	update_hud()
	if not userid.steamid == 'BOT':
		if spawn_protection:
			es.server.queuecmd('est_god %d 1' % userid)
			es.server.queuecmd('est_setplayercolor %d 255 75 75 100 1' % userid)
			gamethread.delayed(spawn_protection, es.server.queuecmd, ('est_god %d 0' % userid))
			gamethread.delayed(spawn_protection, es.server.queuecmd, ('est_setplayercolor %d 255 255 255 255 1' % userid))



def player_death(ev):
	userid = ev['userid']
	global temp_zombies
	Player(userid).dissolve()
	Player(userid).check_respawn()
	Player(userid).play_sound()
	if temp_zombies <= 0: 
		es.server.queuecmd('est_slay #t')
	if ev['weapon'] == 'knife':
		Player(userid).zombify()
	if ev['headshot'] == '1':
		Player(userid).unzombify()

def player_team(ev):
	Player(ev['userid']).check_team()

def es_map_start(ev):
	global checked
	checked = 0
	add_downloads()
	knife_bot()
	es.server.queuecmd('es_xmexec ../addons/eventscripts/zombiecontainment/zombiecontainment.cfg')
	

def item_pickup(ev):
	Player(ev['userid']).check_restrict(ev['item'])
	if ev['item'] == 'c4': es.server.queuecmd('es_xfire %s weapon_c4 kill'%ev['userid'])

def player_hurt(ev):
	if not random.randint(0, 7):
		Player(ev['userid']).play_sound()
	if int(sv('zc_headshot_only')):
		if not int(ev['hitgroup']) == 1 and not ev['weapon'] in ['weapon_knife', 'weapon_hegrenade']:
			es.setplayerprop(ev['userid'], es.getplayerprop(ev['userid'], 'CBasePlayer.m_iHealth') + int(ev['dmg_health']))

def round_start(ev):
	set_pythonvars()
	global temp_zombies, checked, bossess, wins, survival, difficulty
	if wins == 0:
		playerlib.getPlayer(event_var["userid"]).set("cash", 16000)
		temp_zombies = es.getplayercount(3) * int(sv('zc_stock_zombies')) + int(wins * float(sv('zc_stock_multiplier'))) + int(sv('zc_stock_add'))
	if survival == 1:
		temp_zombies = 1
		es.doblock('buymenu/reset')
		difficulty = 0
		es.msg('#multi', '#lightgreen[Zombie Containment]: #defaultSay !maps to change maps in survival mode.')
	else:
		temp_zombies = es.getplayercount(3) * int(sv('zc_stock_zombies')) + int(wins * float(sv('zc_stock_multiplier'))) + int(sv('zc_stock_add'))
	if es.getUseridList():
		es.server.queuecmd('es_xfire %s hostage_entity kill'%es.getUseridList()[0])
		es.server.queuecmd('es_xfire %s func_bomb_target kill'%es.getUseridList()[0])
		es.server.queuecmd('es_xfire %s func_hostage_rescue kill'%es.getUseridList()[0])
	bossess = []
	lightstyle()
	###mega_boss()
	resetAll()

def round_freeze_end(ev):
	if 0 <= wins:
		es.msg('#multi', '#default%s'%messages[wins])
	global temp_zombies
	if temp_zombies == -1:
		temp_zombies = 0
	if es.getUseridList():
		es.server.queuecmd('es_xfire %s hostage_entity kill'%es.getUseridList()[0])
		es.server.queuecmd('es_xfire %s func_bomb_target kill'%es.getUseridList()[0])
		es.server.queuecmd('es_xfire %s func_hostage_rescue kill'%es.getUseridList()[0])

def round_end(ev):
	round_restart_loader()
	set_pythonvars()
	global wins, survival, temp_zombies
	if es.getplayercount(3) > 0:
		if survival == 1:
			wins = 50
			es.doblock('zombiecontainment_dayandnight/dusk0')
			playerlib.getPlayer(event_var["userid"]).set("cash", 16000)
		else:
			wins = max(0, wins + (1 if not len(playerlib.getPlayerList('#t,#alive')) else 0))
			if wins > rounds_to_win:
				es.msg('#multi', '#lightgreen[Zombie Containment]: #defaultCongratulations on defeating all the zombies, map re-starting in 5 seconds.')
				wins = 0
				es.doblock('buymenu/reset')
				es.doblock('maplevels/reset')
		if wins == mapchange_1:
			es.doblock('maplevels/levelpick1')
			wins += 1
		if wins == mapchange_2:
			es.doblock('maplevels/levelpick1')
			wins += 1
		if wins == mapchange_3:
			es.doblock('maplevels/levelpick1')
			wins += 1
	else:
		es.msg('Not enough players to start')
	knife_bot()
	if checked:
		add_bots()
	checked += 1
	gamethread.cancelDelayed('update_hud')
	update_hud()


def player_disconnect(ev):
	if int(ev['userid']) in coords:
		del coords[int(ev['userid'])]
	##if es.getplayercount(3) == 0:
	##	global wins
	##	wins = 0
	##	es.server.queuecmd('changelevel cs_militia.bsp')

### Classes ###

class Player:
	def __init__(self, userid):
		self.userid = userid
		self.steamid = es.getplayersteamid(userid)

	def dissolve(self):
		if remove_ragdolls:
			gamethread.cancelDelayed('remove_ragdolls')
			gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)
		if temp_zombies == -1:
			gamethread.cancelDelayed('remove_ragdolls')
			gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)
		if survival == 1:
			if temp_zombies == 50:
				gamethread.cancelDelayed('remove_ragdolls')
				gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)
				global difficulty
				difficulty = 1
				es.doblock('zombiecontainment_dayandnight/dusk')
			if temp_zombies == 100:
				gamethread.cancelDelayed('remove_ragdolls')
				gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)
				global difficulty
				difficulty = 2
				es.doblock('zombiecontainment_dayandnight/dusk1')
			if temp_zombies == 150:
				gamethread.cancelDelayed('remove_ragdolls')
				gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)
				global difficulty
				difficulty = 3
			if temp_zombies == 200:
				gamethread.cancelDelayed('remove_ragdolls')
				gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)
			if temp_zombies == 250:
				gamethread.cancelDelayed('remove_ragdolls')
				gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)
			if temp_zombies == 300:
				gamethread.cancelDelayed('remove_ragdolls')
				gamethread.delayedname(0.5, 'remove_ragdolls', es.server.queuecmd, 'es_xfire %s cs_ragdoll kill'%self.userid)

	def check_restrict(self, weapon):
		if es.getplayerteam(self.userid) == 2 and not 'knife' in weapon:
			es.server.queuecmd('es_xgive %s player_weaponstrip'%self.userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip StripWeaponsAndSuit'%self.userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip kill'%self.userid)
			es.server.queuecmd('est_removeidle weapon_knife')
			es.server.queuecmd('est_removeidle weapon_glock')
			gamethread.delayed(1, es.server.queuecmd, 'es_xgive %s weapon_knife'%self.userid)
		elif weapon.replace('weapon_', '') in str(sv('zc_restricted_weapons')):
			handle = es.getplayerhandle(self.userid)
			for index in es.createentitylist('weapon_%s'%weapon.replace('weapon_', '')):
				if handle == int(es.getindexprop(index, "CBaseEntity.m_hOwnerEntity")):
					es.server.queuecmd('es_xremove %s'%index)
					es.tell(self.userid, '#multi', '#greenSorry, the #lightgreen%s #greenis restricted'%(weapon.replace('weapon_', '')))
					es.sexec(self.userid, 'lastinv')
					break

	def check_respawn(self):
		global temp_zombies, survival
		if es.getplayerteam(self.userid) == 2:
			if temp_zombies > 0:
				if survival == 1:
					temp_zombies += 1
				else:
					temp_zombies -= 1
				gamethread.delayed(2, es.server.queuecmd, 'est_spawn %s'%self.userid)


	def zombify(self):
		if infection == 1:
			if es.getlivingplayercount(3) >= 1:
				if es.exists('userid', self.userid):
					if playerlib.getPlayer(self.userid).get('teamid') == 3:
						es.server.queuecmd('est_team %s 2'%self.userid)
						gamethread.delayed(2, es.server.queuecmd, 'est_spawn %s'%self.userid)

	def round_restart(self):
		if es.exists('userid', self.userid):
			if self.steamid == 'BOT':
				if not playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 2'%self.userid)
			else:
				if playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 3'%self.userid)
					playerlib.getPlayer(self.userid).set('health', 35000)


	def player_spawn_msg(self):
		if es.exists('userid', self.userid):
			if playerlib.getPlayer(self.userid).get('teamid') == 2:
				if not self.steamid == 'BOT':
					es.centertell(self.userid, 'You have come back as a zombie.  Go search for brains.')

	def unzombify(self):
		if es.exists('userid', self.userid):
			if not self.steamid == 'BOT':
				if playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 3'%self.userid)
					gamethread.delayed(2, es.server.queuecmd, 'est_spawn %s'%self.userid)
					es.centertell(self.userid, 'A headshot will stop zombies from coming back')




	def set_attributes(self, model):
		if es.getplayerteam(self.userid) == 2:
			if not wins in attributes:
				if random.randint(1, 100) > float(sv('zc_boss_chance')) or wins < rounds_to_win:
					self.set_attributes_norm()
				else:
					bossess.append(int(self.userid))
					playerlib.getPlayer(self.userid).set('model', random.choice(str(sv('zc_boss_model')).split(',')))
					es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', random_value(float(sv('zc_boss_health_min')), int(sv('zc_boss_health_max'))) + (float(sv('zc_boss_player_health_multiplier')) * es.getplayercount()) + (float(sv('zc_difficulty_health_multiplier')) * difficulty))
					es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', random_value(float(sv('zc_boss_speed_min')), float(sv('zc_boss_speed_max'))) + (float(sv('zc_difficulty_speed_multiplier')) * difficulty))
					es.setplayerprop(self.userid, 'CCSPlayer.m_ArmorValue', random_value(int(sv('zc_boss_armor_min')), int(sv('zc_boss_armor_max'))))
					es.server.queuecmd('est_setgravity %s %s'%(self.userid, random_value(float(sv('zc_boss_gravity_min')), float(sv('zc_boss_gravity_max')))))
				es.setplayerprop(self.userid, 'CCSPlayer.m_iAccount', 0)
			else:
				atrs = attributes[wins]
				if random.randint(0, 100) < atrs['chance']:
					if atrs['boss']:
						bossess.append(int(self.userid))
					playerlib.getPlayer(self.userid).set('model', random.choice(atrs['model'].split(',')))
					es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', random_value(atrs['min_health'], atrs['max_health']) + (float(sv('zc_zombie_player_health_multiplier')) * es.getplayercount()) + (float(sv('zc_difficulty_health_multiplier')) * difficulty))
					es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', random_value(atrs['min_speed'], atrs['max_speed']) + (float(sv('zc_zombie_player_speed_multiplier')) * es.getplayercount()) + (float(sv('zc_difficulty_speed_multiplier')) * difficulty))
					es.setplayerprop(self.userid, 'CCSPlayer.m_ArmorValue', random_value(atrs['min_armor'], atrs['max_armor']))
					es.server.queuecmd('est_setgravity %s %s'%(self.userid, random_value(atrs['min_gravity'], atrs['max_gravity'])))
				else:
					self.set_attributes_norm()
			if wins == rounds_to_win:
				if random.randint(1, 100) < float(sv('zc_boss_chance')):
					bossess.append(int(self.userid))
					playerlib.getPlayer(self.userid).set('model', random.choice(str(sv('zc_boss_model')).split(',')))
					es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', random_value(float(sv('zc_boss_health_min')), int(sv('zc_boss_health_max'))) + (float(sv('zc_boss_player_health_multiplier')) * es.getplayercount()) + (float(sv('zc_difficulty_health_multiplier')) * difficulty))
					es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', random_value(float(sv('zc_boss_speed_min')), float(sv('zc_boss_speed_max'))) + (float(sv('zc_difficulty_speed_multiplier')) * difficulty))
					es.setplayerprop(self.userid, 'CCSPlayer.m_ArmorValue', random_value(int(sv('zc_boss_armor_min')), int(sv('zc_boss_armor_max'))))
					es.server.queuecmd('est_setgravity %s %s'%(self.userid, random_value(float(sv('zc_boss_gravity_min')), float(sv('zc_boss_gravity_max')))))
				es.setplayerprop(self.userid, 'CCSPlayer.m_iAccount', 0)
		else:
			es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', float(sv('zc_human_speed')))
		
	
	def set_attributes_norm(self):
		if survival == 1:
			playerlib.getPlayer(self.userid).set('model', random.choice(zombie_models))
			es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', random_value(health_min, health_max) + (wins * health_multiplier) + (float(sv('zc_zombie_player_health_multiplier')) * es.getplayercount()) + 35 + (float(sv('zc_difficulty_health_multiplier')) * difficulty))
			es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', random_value(speed_min, speed_max) + (wins * speed_multiplier) + (float(sv('zc_zombie_player_speed_multiplier')) * es.getplayercount()) + (float(sv('zc_difficulty_speed_multiplier')) * difficulty))
			es.setplayerprop(self.userid, 'CCSPlayer.m_ArmorValue', random_value(armor_min, armor_max) + (wins * armor_multiplier) + 50 + (float(sv('zc_zombie_player_armor_multiplier')) * es.getplayercount()))
			es.server.queuecmd('est_setgravity %s %s'%(self.userid, random_value(gravity_min, gravity_max) - (wins * gravity_multiplier)))
		else:
			playerlib.getPlayer(self.userid).set('model', random.choice(zombie_models))
			es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', random_value(health_min, health_max) + (wins * health_multiplier) + (float(sv('zc_zombie_player_health_multiplier')) * es.getplayercount()) + (float(sv('zc_difficulty_health_multiplier')) * difficulty))
			es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', random_value(speed_min, speed_max) + (wins * speed_multiplier) + (float(sv('zc_zombie_player_speed_multiplier')) * es.getplayercount()) + (float(sv('zc_difficulty_speed_multiplier')) * difficulty))
			es.setplayerprop(self.userid, 'CCSPlayer.m_ArmorValue', random_value(armor_min, armor_max) + (wins * armor_multiplier) + (float(sv('zc_zombie_player_armor_multiplier')) * es.getplayercount()))
			es.server.queuecmd('est_setgravity %s %s'%(self.userid, random_value(gravity_min, gravity_max) - (wins * gravity_multiplier)))

	def play_sound(self):
		if es.getplayerteam(self.userid) == 2:
			sounds = []
			for a in range(1, 10):
				if a < 5:
					sounds.append('npc/zombie/moan_loop' + str(a))
				if a < 4:
					sounds.append('npc/zombie/zombie_die' + str(a))
					sounds.append('npc/zombie/zombie_alert' + str(a))
				if sounds < 7:
					sounds.append('npc/zombie/zombie_pain' + str(a))
				sounds.append('npc/zombie/zombie_voice_idle' + str(a))
			sound = random.choice(sounds)
			es.emitsound('player', self.userid, sound + '.wav', 0.75, 0.4)
			gamethread.delayed(3, es.stopsound, (self.userid, sound + '.wav'))



	def health_bonus(self):
		if int(sv('zc_few_humans_hp_bonus')):
			if es.getplayerteam(self.userid) == 3:
				if es.getplayercount(3) <= int(sv('zc_few_humans_hp_bonus')):	
					es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', max(100, int(sv('zc_start_hp_value')) - (int(sv('zc_per_human_hp_loss')) * es.getplayercount(3))) - (int(sv('zc_difficulty_humanhealthsubtract_multiplier')) * difficulty))
					es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', random_value(float(sv('zc_human_speed'))))


	def hud(self):
		global temp_zombies, wins, difficulty, infection, respawn, survival
		humans = 0
		zombies = 0
		for userid in playerlib.getUseridList('#ct,#alive'):
			humans += 1
		if survival == 1:
			zombies = temp_zombies - 1
			usermsg.hudhint(self.userid, 'Survival Mode\nHumans: %s \nZombies killed: %s\nDifficulty: %s\n %s'%(humans, zombies, difficultylevel[difficulty], infectionorrespawn[infection]))
		else:
			usermsg.hudhint(self.userid, '%s\nHumans: %s | Zombies: %s\nDifficulty: %s\n %s'%(timeofday[wins], humans, temp_zombies, difficultylevel[difficulty], infectionorrespawn[infection]))

	def check_team(self):
		if infection == 0:
			if es.exists('userid', self.userid):
				if self.steamid == 'BOT':
					if not playerlib.getPlayer(self.userid).get('teamid') == 2:
						es.server.queuecmd('est_team %s 2'%self.userid)
				else:
					if playerlib.getPlayer(self.userid).get('teamid') == 2:
						es.server.queuecmd('est_team %s 3'%self.userid)
						es.tell(self.userid, '#multi', '#lightgreen[Zombie Containment]: #defaultOnly bots can be zombies during Respawn Mode. Say #green!infection #defaultfor Infection Mode')
						es.server.queuecmd('est_spawn %s'%self.userid)




### Functions ###




def set_pythonvars():
	global health_min, health_max, speed_min, speed_max, zombie_models, health_multiplier, speed_multiplier, armor_min, armor_max, armor_multiplier, gravity_min, gravity_max, gravity_multiplier
	global rounds_to_win, remove_ragdolls, mapchange_1, mapchange_2, mapchange_3 
	zombie_models = str(sv('zc_zombie_models')).split(',')
	health_min, health_max, health_multiplier = tuple(int(sv('zc_zombie_health_' + x)) for x in ['min', 'max', 'level_bonus_multiplier'])
	speed_min, speed_max, speed_multiplier = tuple(float(sv('zc_zombie_speed_' + x)) for x in ['min', 'max', 'level_bonus_multiplier'])
	armor_min, armor_max, armor_multiplier = tuple(int(sv('zc_zombie_armor_' + x)) for x in ['min', 'max', 'level_bonus_multiplier'])
	gravity_min, gravity_max, gravity_multiplier = tuple(float(sv('zc_zombie_gravity_' + x)) for x in ['min', 'max', 'level_bonus_multiplier'])
	rounds_to_win, remove_ragdolls, mapchange_1, mapchange_2, mapchange_3 = tuple(int(sv('zc_' + x)) for x in ['rounds_to_win', 'remove_ragdolls', 'mapchange_1', 'mapchange_2', 'mapchange_3'])

def add_downloads():
	if os.path.isfile(es.getAddonPath('zombiecontainment') + '/downloads.cfg'):
		for a in return_downloads():
			es.stringtable('downloadables', a)

def knife_bot():
	es.server.queuecmd('bot_knives_only 1')
	es.server.queuecmd('bot_join_after_player 0')
	es.server.queuecmd('bot_join_team t')
	es.server.queuecmd('bot_difficulty 3')
	es.server.queuecmd('bot_allow_rogues 0')
	es.server.queuecmd('bot_auto_follow 1')
	es.server.queuecmd('bot_defer_to_human 0')
	es.server.queuecmd('bot_auto_vacate 0')
	es.set('mp_limitteams', 0)
	es.set('mp_autoteambalance', 0)

def add_bots():
	es.server.queuecmd('bot_quota %s'%int(sv('zc_bots')))

def kick_bots():
	es.server.queuecmd('bot_kick')


def mega_boss():
	if wins == rounds_to_win:
		global temp_zombies
		temp_zombies = -1
		zombies = es.getplayercount(2)
		for userid in playerlib.getUseridList('#t'):
			if zombies > 4:
				zombies -= 1
				es.server.queuecmd('est_slay %s'%userid)
		playerlib.getPlayer(userid).set('health', 8000 + (wins * float(sv('zc_zombie_health_level_bonus_multiplier'))) + (float(sv('zc_zombie_player_health_multiplier')) * es.getplayercount()))
		playerlib.getPlayer(userid).set('speed', 1.05 + (wins * float(sv('zc_zombie_speed_level_bonus_multiplier'))))
		playerlib.getPlayer(userid).set('armor', 500 + (wins * float(sv('zc_zombie_armor_level_bonus_multiplier'))) + (float(sv('zc_zombie_player_armor_multiplier')) * es.getplayercount()))
		playerlib.getPlayer(userid).set('model', 'player/slow/el_g_fix2/slow_gigante')
		for userid in es.getUseridList():
			usermsg.shake(userid, 40, 5.5)
		### bossess.append(int(userid))



def lightstyle():
	if wins == 0: 		
		es.doblock('zombiecontainment_dayandnight/dusk0')
	if wins == 1: 		
		es.doblock('zombiecontainment_dayandnight/dusk')
	if wins == 2: 		
		es.doblock('zombiecontainment_dayandnight/dusk1')
	if wins == 3: 		
		es.doblock('zombiecontainment_dayandnight/midnight')
	if wins == 4: 		
		es.doblock('zombiecontainment_dayandnight/dawn')
	if wins == 5: 		
		es.doblock('zombiecontainment_dayandnight/dawn1')	
	if wins == 6: 		
		es.doblock('zombiecontainment_dayandnight/daylight')
	if wins == 10: 		
		es.doblock('zombiecontainment_dayandnight/dusk0')
	if wins == 11: 		
		es.doblock('zombiecontainment_dayandnight/dusk')
	if wins == 12: 		
		es.doblock('zombiecontainment_dayandnight/dusk1')
	if wins == 13: 		
		es.doblock('zombiecontainment_dayandnight/midnight')
	if wins == 14: 		
		es.doblock('zombiecontainment_dayandnight/dawn')
	if wins == 15: 		
		es.doblock('zombiecontainment_dayandnight/dawn1')	
	if wins == 16: 		
		es.doblock('zombiecontainment_dayandnight/daylight')
	if wins == 20: 		
		es.doblock('zombiecontainment_dayandnight/dusk0')
	if wins == 21: 		
		es.doblock('zombiecontainment_dayandnight/dusk')
	if wins == 22: 		
		es.doblock('zombiecontainment_dayandnight/dusk1')
	if wins == 23: 		
		es.doblock('zombiecontainment_dayandnight/midnight')
	if wins == 24: 		
		es.doblock('zombiecontainment_dayandnight/dawn')
	if wins == 25: 		
		es.doblock('zombiecontainment_dayandnight/dawn1')	
	if wins == 26: 		
		es.doblock('zombiecontainment_dayandnight/daylight')	
	if wins == 30: 		
		es.doblock('zombiecontainment_dayandnight/dusk0')
	if wins == 31: 		
		es.doblock('zombiecontainment_dayandnight/dusk')
	if wins == 32: 		
		es.doblock('zombiecontainment_dayandnight/dusk1')
	if wins == 33: 		
		es.doblock('zombiecontainment_dayandnight/midnight')
	if wins == 34: 		
		es.doblock('zombiecontainment_dayandnight/dawn')
	if wins == 35: 		
		es.doblock('zombiecontainment_dayandnight/dawn1')	
	if wins == 36: 		
		es.doblock('zombiecontainment_dayandnight/daylight')
	if wins == 40: 		
		es.doblock('zombiecontainment_dayandnight/dusk0')
	if wins == 41: 		
		es.doblock('zombiecontainment_dayandnight/dusk')
	if wins == 42: 		
		es.doblock('zombiecontainment_dayandnight/dusk1')
	if wins == 43: 		
		es.doblock('zombiecontainment_dayandnight/midnight')
	if wins == 44: 		
		es.doblock('zombiecontainment_dayandnight/dawn')
	if wins == 45: 		
		es.doblock('zombiecontainment_dayandnight/dawn1')	
	if wins == 46: 		
		es.doblock('zombiecontainment_dayandnight/daylight')

def difficulty1():
	global difficulty
	difficulty = 0

def difficulty2():
	global difficulty
	difficulty = 1

def difficulty3():
	global difficulty
	difficulty = 2

def survivalmode():
	global survival
	survival = 1
	es.msg('#multi', '#lightgreen[Survival Mode]: #defaultEndabled. See how many zombies you can kill!')
	es.server.queuecmd('mp_restartgame 2')
	es.doblock('maplevels/levelfun1popup')

def storymode():
	global survival, difficulty, wins
	wins = 0
	survival = 0
	difficulty = 1
	es.server.queuecmd('mp_restartgame 2')
	es.doblock('maplevels/level1pick')


def infectionmode():
	global infection
	infection = 1

	
def respawnmode():
	global infection
	infection = 0
	change_teams()


def change_teams():
	for userid in es.getUseridList():
		Player(userid).check_team()

def finishdif(votename, win, winname, winvotes, winpercent, total, tie, cancelled): 
	if cancelled: 
		es.msg("The vote "+votename+" was cancelled.") 
	else: 
		es.msg("The option "+winname+" ["+str(win)+"] has won the vote with "+str(winvotes)+" ("+str(winpercent)+"%) votes.") 
	if winname == 'Easy':
		global difficulty
		difficulty = 0
	if winname == 'Normal':
		global difficulty
		difficulty = 1
	if winname == 'Hard': 
		global difficulty
		difficulty = 2
	if winname == 'Impossible': 
		global difficulty
		difficulty = 3

def finishir(votename, win, winname, winvotes, winpercent, total, tie, cancelled): 
	if cancelled: 
		es.msg("The vote "+votename+" was cancelled.") 
	else: 
		es.msg("The option "+winname+" ["+str(win)+"] has won the vote with "+str(winvotes)+" ("+str(winpercent)+"%) votes.") 
	if winname == 'Respawn':
		global infection
		infection = 0
		change_teams()
	elif winname == 'Infection':
		global infection
		infection = 1

def finishmusic(votename, win, winname, winvotes, winpercent, total, tie, cancelled): 
	if cancelled: 
		es.msg("The vote "+votename+" was cancelled.") 
	else: 
		es.msg("The option "+winname+" ["+str(win)+"] has won the vote with "+str(winvotes)+" ("+str(winpercent)+"%) votes.") 
	if winname == 'on':
		es.load('cssoundtrack')
	elif winname == 'off':
		es.unload('cssoundtrack')

def finishsur(votename, win, winname, winvotes, winpercent, total, tie, cancelled): 
	if cancelled: 
		es.msg("The vote "+votename+" was cancelled.") 
	else: 
		es.msg("The option "+winname+" ["+str(win)+"] has won the vote with "+str(winvotes)+" ("+str(winpercent)+"%) votes.") 
	if winname == 'Story':
		global survival, difficulty, wins, temp_zombies
		wins = 0
		survival = 0
		difficulty = 1
		es.server.queuecmd('mp_restartgame 2')
		es.doblock('maplevels/level1pick')
		temp_zombies = es.getplayercount(3) * int(sv('zc_stock_zombies')) + int(wins * float(sv('zc_stock_multiplier'))) + int(sv('zc_stock_add'))
	elif winname == 'Survival':
		global survival, temp_zombies
		survival = 1
		es.msg('#multi', '#lightgreen[Survival Mode]: #defaultEndabled. See how many zombies you can kill!')
		es.server.queuecmd('mp_restartgame 2')
		es.doblock('maplevels/levelfun1popup')
		## temp_zombies = 1


def submitdif(userid, votename, choice, choicename):
	tell(userid, "You selected item "+choicename+" ["+str(choice)+"] from "+votename+"") 

def submitir(userid, votename, choice, choicename):
	tell(userid, "You selected item "+choicename+" ["+str(choice)+"] from "+votename+"") 

def submitmusic(userid, votename, choice, choicename):
	tell(userid, "You selected item "+choicename+" ["+str(choice)+"] from "+votename+"")
 
def submitsur(userid, votename, choice, choicename):
	tell(userid, "You selected item "+choicename+" ["+str(choice)+"] from "+votename+"")

def votedifficulty():
	difvote.start(30)
 
def voteir():
	irvote.start(30)

def votemusic():
	musicvote.start(30)

def votesur():
	survote.start(30)

def round_restart_loader():
	for userid in es.getUseridList():
		Player(userid).round_restart()

def resetAll():
	global t_wave_remaining, ct_wave_remaining
	t_wave_remaining  = respawn_rate
	ct_wave_remaining = respawn_rate
	gamethread.cancelDelayed('waveRepeat_delay')
	waveRepeat()

### Returns ###

def random_value(low, high):
	return random.randint(int(low * 1000), int(high * 1000)) / 1000.0

def return_downloads():
	if os.path.isfile(es.getAddonPath('zombiecontainment') + '/downloads.cfg'):
		a = open(es.getAddonPath('zombiecontainment') + '/downloads.cfg', 'r')
		b = a.readlines()
		a.close()
		return map(lambda x: x.replace('\n', '').replace('\\', '/').replace('downloadable', ''), filter(lambda x: not x.startswith('//') and not x == '\n', b))
	else:
		es.dbgmsg(0, 'ERROR: No downloads.cfg found for Zombie Containment!')


### Loops ###

def bot_check_loop():
	gamethread.delayedname(30, 'check_quota', bot_check_loop)
	if es.getplayercount(2) < int(sv('zc_bots')):
		add_bots()

def update_hud():
	for userid in es.getUseridList():
		Player(userid).hud()
	gamethread.delayedname(2, 'update_hud', update_hud)

def waveRepeat():
	global t_wave_remaining, ct_wave_remaining
	for userid in es.getUseridList():
		team = es.getplayerteam(userid)		
		if playerlib.getPlayer(userid).get('isdead'):
			if team == 2:
				es.centertell(userid, 'Time until respawn: %s' % t_wave_remaining)
				if t_wave_remaining < 1:
					es.server.queuecmd('est_spawn %s' % userid)
			elif team == 3:
				es.centertell(userid, 'Time until respawn: %s' % ct_wave_remaining)
				if ct_wave_remaining < 1:
					es.server.queuecmd('est_spawn %s' % userid)
		else:
			if team == 2:
				if es.getlivingplayercount(2) == 1:
					if es.getplayercount(2) > 1:
						es.centertell(userid, 'Stay alive, reinforcements in %s' % t_wave_remaining)
			elif team == 3:
				if es.getlivingplayercount(3) == 1:
					if es.getplayercount(3) > 1:
						es.centertell(userid, 'Stay alive, reinforcements in %s' % ct_wave_remaining)
	if t_wave_remaining < 1:
		t_wave_remaining = respawn_rate
	if ct_wave_remaining < 1:
		ct_wave_remaining = respawn_rate
	t_wave_remaining -= 1
	ct_wave_remaining -= 1
	gamethread.delayedname(1, 'waveRepeat_delay', waveRepeat)

### Client/Say Commands

def zc():
	args = es.getargs()
	if args:
		args = args.lower().replace('"', '').split(' ')
		if len(args) >= 2:
			if args[0] in zc_command_args:
				if args[1] in zc_command_args[args[0]]:
					if len(args) >= zc_command_args[args[0]][args[1]][0]:
						if args[0] == 'add':
							if args[1] == 'levelmessage':
								try:
									int(args[2])
								except:
									es.dbgmsg(0, 'Zombie Containment Error: Non integer amount for zc %s %s, %s'%(args[0], args[1], args[2]))
									return
								messages[int(args[2])] = ' '.join(args[3:])
					else:
						es.dbgmsg(0, 'Zombie Containment Error: Not enough arguments for zc %s %s'%(args[0], args[1]))
						es.dbgmsg(0, 'Zombie Containment Syntax: zc %s %s %s'%(args[0], args[1], zc_command_args[args[0]][args[1]][1]))
				else:
					es.dbgmsg(0, 'Zombie Containment Error: Invalid subcommand for zc %s, %s'%(args[0], args[1]))
					es.dbgmsg(0, 'Zombie Containment Syntax: Valid commands are %s'%', '.join(zc_command_args[args[0]].keys()))
			else:
				es.dbgmsg(0, 'Zombie Containment Error: Invalid subcommand for zc, %s'%args[0])
				es.dbgmsg(0, 'Zombie Containment Syntax: Valid commands are %s'%', '.join(zc_command_args.keys()))
		else:
			es.dbgmsg(0, 'Zombie Containment Error: No subcommand present, cannot continue!')
			es.dbgmsg(0, 'Zombie Containment Syntax: Valid subcommands are %s'%', '.join(zc_command_args.keys()))

### Call Functions ###

gamethread.delayed(0, update_hud)
gamethread.delayed(0, bot_check_loop)